package urgrip.programnodes;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.ContributionConfiguration;
import com.ur.urcap.api.contribution.program.CreationContext;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeService;
import com.ur.urcap.api.domain.data.DataModel;

import java.util.Locale;

public class GripperNodeService implements SwingProgramNodeService<GripperNodeContribution, GripperNodeView> {


    @Override
    public String getId() {
        return "Grip";
    }

    @Override
    public void configureContribution(ContributionConfiguration configuration) {
        configuration.setChildrenAllowed(false);
    }

    @Override
    public String getTitle(Locale locale) {
        return "Grip";
    }

    @Override
    public GripperNodeView createView(ViewAPIProvider apiProvider) {
        return new GripperNodeView(new V5Style());
    }

    @Override
    public GripperNodeContribution createNode(
            ProgramAPIProvider apiProvider,
            GripperNodeView view,
            DataModel model,
            CreationContext context) {
        return new GripperNodeContribution(apiProvider, view, model);
    }

    public GripperNodeService() {

    }
}
